package zander.library.media;

import java.awt.Graphics;
import java.awt.image.BufferedImage;

import javax.swing.JComponent;

public class ImageMediaComponent extends JComponent {
    private static final long serialVersionUID = -471866227150575822L;

    private transient SerializableImageContainer image;

    public ImageMediaComponent(BufferedImage image) {
        setOpaque(false);
        this.image = new SerializableImageContainer(image);
    }

    public ImageMediaComponent(SerializableImageContainer image) {
        setOpaque(false);
        this.image = image;
    }

    public BufferedImage getImage() {
        return image.getImage();
    }

    @Override
    protected void paintComponent(Graphics g) {
        BufferedImage image = this.image.getImage();
        int cw = getWidth();
        int ch = getHeight();
        int iw = image.getWidth();
        int ih = image.getHeight();
        float scale = Math.min((float) cw / iw, (float) ch / ih);
        int fw = (int) Math.floor(scale * iw);
        int fh = (int) Math.floor(scale * ih);
        int fx = (cw / 2) - (fw / 2);
        int fy = (ch / 2) - (fh / 2);
        g.drawImage(image, fx, fy, fw, fh, null);
    }

}
