package zander.ui;

import java.awt.Graphics;

import javax.swing.JComponent;

import zander.library.media.SerializableImageContainer;

public class OverlayPainterComponent extends JComponent {
    private static final long serialVersionUID = -91235129812512L;

    private final SerializableImageContainer img;
    private int x;
    private int y;
    private int w;
    private int h;

    public OverlayPainterComponent(SerializableImageContainer img, int x, int y, int w, int h) {
        this.img = img;
        this.x = x;
        this.y = y;
        this.w = w;
        this.h = h;
        setOpaque(false);
    }

    @Override
    protected void paintComponent(Graphics g) {
        g.drawImage(img.getImage(), x, y, w, h, null);
    }

    public int getOverlayX() {
        return x;
    }

    public int getOverlayY() {
        return y;
    }

    public int getOverlayWidth() {
        return w;
    }

    public int getOverlayHeight() {
        return h;
    }

    public void setOverlayBounds(int x, int y, int w, int h) {
        this.x = x;
        this.y = y;
        this.w = w;
        this.h = h;
    }

}
