package zander.ui.album;

import java.util.EventObject;

import zander.library.state.AlbumState;

public class AlbumPropertyUpdateEvent extends EventObject {
    private static final long serialVersionUID = 1836669249042617105L;

    public static enum AlbumEventProperty {
        NAME,
        TITLE,
        THUMBNAIL
    }

    private final AlbumState source;
    private final String oldValue;
    private final String newValue;
    private final AlbumEventProperty property;

    public AlbumPropertyUpdateEvent(AlbumState source, String oldValue, String newValue, AlbumEventProperty property) {
        super(source);
        this.source = source;
        this.oldValue = oldValue;
        this.newValue = newValue;
        this.property = property;
    }

    public AlbumEventProperty getProperty() {
        return property;
    }

    public String getNewValue() {
        return newValue;
    }

    public String getOldValue() {
        return oldValue;
    }

    @Override
    public AlbumState getSource() {
        return source;
    }
}
