package zander.ui.library;

import java.awt.BorderLayout;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Window;
import java.awt.event.KeyEvent;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.UIManager;

import zander.ui.UIUtils;

public class LibraryDeleteDialog extends JDialog {
    private static final long serialVersionUID = 1L;

    public static final int RESPONSE_CANCEL = 0;
    public static final int RESPONSE_DELETE = 1;

    private int response = RESPONSE_CANCEL;

    private final JLabel iconLabel;
    private final JLabel messageLabel;
    private final JCheckBox diskBox;
    private final JPanel dialogPanel;
    private final JButton cancelButton;
    private final JButton deleteButton;
    private final JPanel buttonPanel;
    private final JPanel content;

    public LibraryDeleteDialog(Window parent, String name) {
        super(parent, "Delete Library");
        iconLabel = new JLabel(UIManager.getIcon("OptionPane.questionIcon"));
        messageLabel = new JLabel("Are you sure you would like to delete the library '" + name + "'?");
        diskBox = new JCheckBox("Delete From Disk (Cannot Be Undone)");
        dialogPanel = new JPanel(new GridBagLayout());
        GridBagConstraints gbc = new GridBagConstraints();
        gbc.gridy = 0;
        gbc.gridx = 0;
        dialogPanel.add(iconLabel, gbc);
        gbc.gridx = 1;
        dialogPanel.add(messageLabel, gbc);
        gbc.gridy = 1;
        gbc.gridx = 0;
        gbc.gridwidth = 2;
        dialogPanel.add(diskBox, gbc);
        cancelButton = new JButton("Cancel");
        cancelButton.setMnemonic(KeyEvent.VK_C);
        cancelButton.addActionListener((e) -> {
                dispose();
            });
        deleteButton = new JButton("Delete");
        cancelButton.setMnemonic(KeyEvent.VK_D);
        deleteButton.addActionListener((e) -> {
                dispose();
                response = RESPONSE_DELETE;
            });
        buttonPanel = new JPanel();
        buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
        buttonPanel.add(cancelButton);
        buttonPanel.add(Box.createHorizontalGlue());
        buttonPanel.add(deleteButton);
        content = new JPanel(new BorderLayout());
        content.add(dialogPanel, BorderLayout.CENTER);
        content.add(buttonPanel, BorderLayout.PAGE_END);
        setContentPane(content);
        setModalityType(JDialog.DEFAULT_MODALITY_TYPE);
        setAlwaysOnTop(true);
        setResizable(false);
        setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
        pack();
        UIUtils.centerWindow(this, parent);
    }

    public int getResponse() {
        return response;
    }

    public boolean isDeleteFromDisk() {
        return diskBox.isSelected();
    }

}
